function [v,Cov_vv] = Euclidean_normalization(v, Cov_vv, entity)

% cf. S. Heuel (2004), Table 4.1

o = zeros(2,1);
Id = eye(2);

switch entity
    
    case 'straight line'
        lh = v(1:2);
        lo = v(3);
        Jac = [ ...
            Id-lh*lh'/norm(lh)^2,  o; ...
            -lo*lh'/norm(lh)^2,        1 ...
            ] / norm(lh);
        Cov_vv = Jac*Cov_vv*Jac';
        v = v / norm(lh);
        
    case 'point'
        xo = v(1:2);
        xh = v(3);
        Jac = [ ...
            Id,  -xo/xh; ...
            o',     0.0 ...
            ]  / xh;
        v = v/v(3);
        Cov_vv = Jac*Cov_vv*Jac';
    otherwise
        error('unknown geometrc entity %s', entity)
end

return