function B = adj(A)

% adjoint matrix.
% 
% B = adj(A) computed the adjoint matrix B of A
%
% inv(A) = adj(A)'/det(A)   holds.
%   d det(A)/ dA = adj(A)   holds.
%
% author:  J. Meidow, FGAN-FOM
%
% $Log: adj.m,v $
% Revision 1.1  2009/08/03 13:39:34  Meidow
% *** empty log message ***
%
% Revision 1.1  2009/06/23 09:07:36  Meidow
% *** empty log message ***
%
% Revision 1.1  2007/09/26 06:33:52  meidow
% *** empty log message ***
%

B = zeros(size(A));
for i=1:size(A,1)
    idx_i = setdiff( 1:size(A,1), i);
    for j=1:size(A,2)
        
        idx_j = setdiff( 1:size(A,2),j);
        B(i,j) = (-1)^(i+j)*det(A(idx_i,idx_j));
    end
end

return