function R = Rot_v1v2(a,b)

% rotation between two directions a and b
%
% arguments:
%   a,b: direction vectors (3,1)
% returns:
%   R:   rotation matrix (3,3)
%
% J. Meidow
% Inst. for Photogrammetry
% Univ. Bonn

% (1) normalize vectors
a = a(:)/norm(a);
b = b(:)/norm(b);

% (2) rotation matrix
if abs(a'*b+1) < sqrt(eps)  % i.e.  a==-b 
   fprintf('%s: a==-b\n', mfilename)
   R = eye(3) +2*b*a';
else
   R = eye(3)  -(a+b)*(a+b)'./(1+a'*b)  +2*b*a';
end

return