function F = approx_estim_F( x1, x2)

% estimation of the fundamental matrix: direct algebraic solution
%
% F = approx_estim_F_mat( x1, x2)
%
% author: J. Meidow, FGAN-FOM
%
% TODO: conditioning
%
% $Log: approx_estim_F.m,v $
% Revision 1.1  2009/06/26 17:58:32  meidow
% *** empty log message ***
%
% Revision 1.1  2007/10/27 21:01:07  meidow
% *** empty log message ***
%

% (1) SVD solution for F
N = size(x1,2);
A = zeros(N,9);
for i=1:N
    A(i,:) = kron( x2(:,i)', x1(:,i)');
end
[U,S,V] = svd(A,0);
[dump, i] = min( diag(S) );
F = reshape( V(:,i) , 3, 3);

% (2) rank-2 enforcement
[U,S,V] = svd(F);
F = U(:,1:2)*S(1:2,1:2)*V(:,1:2)';

return