function [cl, KK] = cfun( l )

%% constraints c(l) for observations l only

K = length(l)/3;
G = length(l)/6;
N = length(l);

% memory allocation
cl = zeros(K,1);
KK = spalloc( G, N, N);

for i=1:G
    
    % indices
    idx1 = 6*(i-1)+(1:3);
    idx2 = 6*(i-1)+(4:6);
    x1 = l( idx1 );
    x2 = l( idx2 );
    
    cl(2*i-1) = ( x1'*x1 -1.0)/2;   % contradictions
    cl(2*i  ) = ( x2'*x2 -1.0)/2;

    KK( 2*(i-1)+1, idx1) = x1';
    KK( 2*(i-1)+2, idx2) = x2';

end

return