function [x1, x2, Fo, F_true, X] = gen_synth_data(P1, P2, P, sigma_n )

%% true F matrix from (P1, P2)
A1 = P1(1:3,1:3);
a1 = P1(:,4);
A2 = P2(1:3,1:3);
a2 = P2(:,4);
b = inv(A2)*a2 -inv(A1)*a1;
F_true = inv(A1)*skew(b)*inv(A2);
F_true = F_true/norm(F_true,'fro');


%%
X = randn(3,P);
x1 = P1*[X; ones(1,P)];
x2 = P2*[X; ones(1,P)];

%% add Gaussian noise to Euclidean part
x1 = [ x1(1,:)./x1(3,:);  x1(2,:)./x1(3,:) ];
x2 = [ x2(1,:)./x2(3,:);  x2(2,:)./x2(3,:) ];

x1 = x1 +sigma_n*randn(size(x1));
x2 = x2 +sigma_n*randn(size(x2));

x1(3,:) = ones(1,P);
x2(3,:) = ones(1,P);

Fo = approx_estim_F( x1, x2);

return