function [cg, AA, BB] = gfun( l, p)

% g(l,p)= 0,    i.e. x'Fx = 0

G = length(l)/6;
U = numel(p);
N = length(l);


cg = zeros( G,1);             % memory allocation
AA = zeros( G,U);
BB = spalloc( G, N,  N);

FF = reshape(p, 3,3);         % fundamental matrix F
for i=1:G
    idx1 = 6*(i-1)+(1:3);
    idx2 = 6*(i-1)+(4:6);
    x1 = l(idx1);
    x2 = l(idx2);
    cg(  i  ) =  x1'*FF*x2;   % contradiction

    AA(i,1:U) = kron( x2', x1' );
    BB( i, [idx1 idx2] ) = [ x2'*FF',  x1'*FF ];
end

return