function SR = SigmaRhoMat(C)

% matrix with standard deviations and correlations from covariance matrix
%
% SR = SigmaRhoMat(C) computes a matrix SR with standard deviations 
% (diagonal) and correlations from a regular covariance matrix.
%
%     author: J. Meidow, FGAN_FOM
%
% 2005, Jan.:  initial code
% 2005, Apr.: function decription added

% standard deviations
s = sqrt(diag(C));

% correlation
R = C ./ (s*s');

% Sigma-Rho-Matrix
n = size(C,1);
i = sub2ind( [n n],1:n,1:n);

SR = R;
SR(i) = s;

return