function [ch, HH ] = hfun( p, idx, IAC)

% constrained vanishing points estimation:
% parameters restrictions h(p)=0

ortho = true;
% ortho = false;  % for comparison

if ortho
    H = 6;
else
    H = 3;
end

%% 3 orthogonal  vanishing points
v1 = p(1:3);
v2 = p(4:6);
v3 = p(7:9);

%% contradictions
ch = zeros(H,1);
ch(1) = v1'*v1 -1.0;
ch(2) = v2'*v2 -1.0;
ch(3) = v3'*v3 -1.0;

if ortho
    ch(4) = v1'*IAC*v2;
    ch(5) = v2'*IAC*v3;
    ch(6) = v1'*IAC*v3;
end

%% Jacobian
HH = zeros( H, 9 );

HH(1,1:3) = 2*v1';     %   v1'v1 = 1,
HH(2,4:6) = 2*v2';     %   v2'v2 = 1
HH(3,7:9) = 2*v3';     %   v3'v3 = 1

if ortho
    HH(4,1:3) = (IAC*v2)';   %   v1'inv(KK')*v2 = 0
    HH(4,4:6) = (IAC*v1)';

    HH(5,4:6) = (IAC*v3)';   %   v2'inv(KK')*v3 = 0
    HH(5,7:9) = (IAC*v2)';

    HH(6,1:3) = (IAC*v3)';   %   v1'inv(KK')*v3 = 0
    HH(6,7:9) = (IAC*v1)';
end

return