function QQ = update_cov( lo, QQ)

% Problem-specific function for the update of the observations' covariance matrix and
%
% QQ = update_cov( lo, QQ )
%
% input: 
%      lo: observations
%      QQ: covariance matrix of observations
% output: 
%      QQ : (updated) covariants matrix of observations

N = length(lo);                   % number of observations

for i=1:N/3   
    % error propagation for spherical normalization
    idx = 3*(i-1)+(1:3);
    x = lo(idx);
    J = ( eye(3) - x*x'/(x'*x) ) / norm(x);
    QQ(idx,idx) = J*QQ(idx,idx)*J';
end

return